precision mediump float;

uniform mat4 uMVPMatrix;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjMatrix;

uniform mat3 uNormalMatrix;
uniform mat4 uModelViewMatrix;

uniform mat4 uBillboardMatrix;

uniform float uAspectRatio;
uniform vec3 uPivot;

uniform vec4 uColor;

attribute vec3 aNormal;
attribute vec2 aTextureCoord;
attribute vec4 aPosition;
varying vec3 vNormal;
varying vec4 vColor;
varying vec2 vTextureCoord;
varying vec3 vEyeDir;
vec4 gColor;
vec4 gPosition;
vec3 gNormal;
vec2 gTextureCoord;

void main() {
	mat4 m = uModelMatrix;
	mat4 v = uViewMatrix;
	mat4 p = uProjMatrix;

	mat4 vm = v*m;
	mat4 vp = p*v;
	mat4 mvp = p*v*m;

    //--------
    mat4 vrot = uBillboardMatrix;

    vec4 bpos = vec4(m[3][0],m[3][1],m[3][2],1.0);
	m[3][0]=uPivot.x;
	m[3][1]=uPivot.y;
	m[3][2]=uPivot.y;// doesn't make a difference

	m[0][0]=1.0;
	m[0][1]=0.0;
	m[0][2]=0.0;
	m[1][0]=0.0;
	m[1][1]=1.0;
	m[1][2]=0.0;
	m[2][0]=0.0;
	m[2][1]=0.0;
	m[2][2]=1.0;


	vec4 pos= vrot * m * aPosition;
	pos.x *= uAspectRatio;

    gl_Position = vp * bpos;
    gl_Position /= gl_Position.w;
    gl_Position.xy += pos.xy;
    //--------------------

	vColor = uColor;//vec4(1,0,0,1);

    gNormal = aNormal;
    gTextureCoord = aTextureCoord;
    vNormal = normalize(uNormalMatrix * gNormal);
    vTextureCoord = gTextureCoord;
    vEyeDir = vec3(uModelViewMatrix * gPosition);
}

